Panda3D

Loading...
Searching...
No Matches
Public Member Functions | List of all members
ArcEmitter Class Reference

Describes a planar ring region in which particles are generated. More...

`#include "arcEmitter.h"`

Inheritance diagram for ArcEmitter:

## Public Member Functions
| ArcEmitter ()
| constructor
| ArcEmitter (const ArcEmitter &copy)
| copy constructor
virtual | ~ArcEmitter ()
| destructor
PN_stdfloat | get_end_angle ()
| get end angle
PN_stdfloat | get_start_angle ()
| get start angle
virtual BaseParticleEmitter * | make_copy ()
| copier
virtual void | output (std::ostream &out) const
| Write a starc representation of this instance to <out>.
void | set_arc (PN_stdfloat startAngle, PN_stdfloat endAngle)
| arc sweep set
void | set_end_angle (PN_stdfloat angle)
| end angle set
void | set_start_angle (PN_stdfloat angle)
| start angle set
virtual void | write (std::ostream &out, int indent=0) const
| Write a starc representation of this instance to <out>.
Public Member Functions inherited from RingEmitter
| RingEmitter ()
| constructor
| RingEmitter (const RingEmitter &copy)
| copy constructor
virtual | ~RingEmitter ()
| destructor
PN_stdfloat | get_angle () const
| angle of elevation get
PN_stdfloat | get_radius () const
| radius get
PN_stdfloat | get_radius_spread () const
| radius_spread get
int | get_uniform_emission () const
| uniform_emission get
void | set_angle (PN_stdfloat angle)
| angle of elevation set
void | set_radius (PN_stdfloat r)
| radius set
void | set_radius_spread (PN_stdfloat spread)
| radius_spread set
void | set_uniform_emission (int uniform_emission)
| uniform_emission set
Public Member Functions inherited from BaseParticleEmitter
virtual | ~BaseParticleEmitter ()
| destructor
void | generate (LPoint3 &pos, LVector3 &vel)
| parent generation function
PN_stdfloat | get_amplitude () const
| amplitude query
PN_stdfloat | get_amplitude_spread () const
| amplitude spread query
emissionType | get_emission_type () const
| emission type query
LVector3 | get_explicit_launch_vector () const
| query for explicit emission launch vector
LVector3 | get_offset_force () const
| user-defined force
LPoint3 | get_radiate_origin () const
| query for explicit emission launch vector
void | set_amplitude (PN_stdfloat a)
| amplitude assignment
void | set_amplitude_spread (PN_stdfloat as)
| amplitude spread assignment
void | set_emission_type (emissionType et)
| emission type assignment
void | set_explicit_launch_vector (const LVector3 &elv)
| assignment of explicit emission launch vector
void | set_offset_force (const LVector3 &of)
| user-defined force
void | set_radiate_origin (const LPoint3 &ro)
| assignment of radiate emission origin point
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)

## Additional Inherited Members
Public Types inherited from BaseParticleEmitter
enum | emissionType { ET_EXPLICIT , ET_RADIATE , ET_CUSTOM }
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Detailed Description

Describes a planar ring region in which particles are generated.

Definition at line 22 of file arcEmitter.h.

## Constructor & Destructor Documentation

## ◆ ArcEmitter() [1/2]

ArcEmitter::ArcEmitter | ( |  | ) |

constructor

Definition at line 19 of file arcEmitter.cxx.

References RingEmitter::RingEmitter().

Referenced by ArcEmitter(), and make_copy().

## ◆ ArcEmitter() [2/2]

ArcEmitter::ArcEmitter | ( | const ArcEmitter & | copy | ) |

copy constructor

Definition at line 28 of file arcEmitter.cxx.

References ArcEmitter(), and RingEmitter::RingEmitter().

## ◆ ~ArcEmitter()

ArcEmitter::~ArcEmitter | ( |  | ) |
| virtual

destructor

Definition at line 38 of file arcEmitter.cxx.

## Member Function Documentation

## ◆ get_end_angle()

PN_stdfloat ArcEmitter::get_end_angle | ( |  | ) |
| inline

get end angle

Definition at line 55 of file arcEmitter.I.

## ◆ get_start_angle()

PN_stdfloat ArcEmitter::get_start_angle | ( |  | ) |
| inline

get start angle

Definition at line 46 of file arcEmitter.I.

## ◆ make_copy()

BaseParticleEmitter * ArcEmitter::make_copy | ( |  | ) |
| virtual

copier

Reimplemented from RingEmitter.

Definition at line 45 of file arcEmitter.cxx.

References ArcEmitter().

## ◆ output()

void ArcEmitter::output | ( | std::ostream & | out | ) | const
| virtual

Write a starc representation of this instance to <out>.

Reimplemented from RingEmitter.

Definition at line 76 of file arcEmitter.cxx.

## ◆ set_arc()

void ArcEmitter::set_arc | ( | PN_stdfloat | startAngle,
|  | PN_stdfloat | endAngle )
| inline

arc sweep set

Definition at line 36 of file arcEmitter.I.

## ◆ set_end_angle()

void ArcEmitter::set_end_angle | ( | PN_stdfloat | angle | ) |
| inline

end angle set

Definition at line 27 of file arcEmitter.I.

## ◆ set_start_angle()

void ArcEmitter::set_start_angle | ( | PN_stdfloat | angle | ) |
| inline

start angle set

Definition at line 18 of file arcEmitter.I.

## ◆ write()

void ArcEmitter::write | ( | std::ostream & | out,
|  | int | indent = 0 ) const
| virtual

Write a starc representation of this instance to <out>.

Reimplemented from RingEmitter.

Definition at line 86 of file arcEmitter.cxx.

References indent(), and RingEmitter::write().

The documentation for this class was generated from the following files:

- panda/src/particlesystem/arcEmitter.h
- panda/src/particlesystem/arcEmitter.cxx
- panda/src/particlesystem/arcEmitter.I